package org.example;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.apache.commons.io.FileUtils;

import java.io.*;
import java.nio.charset.StandardCharsets;

public class DWASearch {

    public static void main(String[] args) throws IOException {
        if (args.length < 2) {
            System.out.println("Usage: java -jar DWASearch.jar input.txt output.txt");
            return;
        }

        String inputFile = args[0];
        String outputFile = args[1];
        BufferedReader br = new BufferedReader(new FileReader(inputFile));
        BufferedWriter bw = new BufferedWriter(new FileWriter(outputFile));
        String line;
        while ((line = br.readLine()) != null) {
            try {
                String[] word = line.split(" ");
                //from here

                if(word[0].equals("players")&&word.length==1)
                {//功能一
                    String jsonFile = "src/data/athletes.json";
                    getAthletes(jsonFile,bw);
                }else if(word[0].equals("result")){
                    if(word[word.length-1].equals("detail")){
                        //附加功能

                    }else{
                        //功能二
                        String[] word1 = line.split(" ",2);//提取文件名
                        String jsonFile = "src/data/" +word1[1]+ ".json";
                        getResultSimple(jsonFile,bw);
                    }
                }
                else{//指令无法识别时
                    bw.write("Error\n-----\n");
                }

            } catch (IOException e) {//文件路径找不到
                bw.write("N/A\n-----\n");
                e.printStackTrace();
        }
        }
        br.close();
        bw.close();
    }

    //功能一
    public static void getAthletes(String jsonFile, BufferedWriter bw) throws IOException {
        String content = FileUtils.readFileToString(new File(jsonFile), StandardCharsets.UTF_8);
        JSONArray jsonArray = JSON.parseArray(content);//层层剥取所需要的信息
        for (int i = 0 ; i <jsonArray.size();i++) {
            JSONObject jsonObject = JSON.parseObject(jsonArray.getString(i));
            JSONArray jsonArray1 = JSON.parseArray(jsonObject.getString("Participations"));
            for(int j = 0 ; j <jsonArray1.size();j++){
                JSONObject jsonObject1 = JSON.parseObject(jsonArray1.getString(j));
                Athlete athlete = new Athlete(jsonObject1.getString("PreferredFirstName"),jsonObject1.getString("PreferredLastName")
                        ,jsonObject1.getString("Gender"),jsonObject1.getString("NAT"));
                bw.write(athlete.toString());
            }
        }
    }


    //功能二
    public static void getResultSimple(String jsonFile,BufferedWriter bw) throws IOException {
        String content = FileUtils.readFileToString(new File(jsonFile), StandardCharsets.UTF_8);
        //剥取json文件信息
        JSONObject jsonObject = JSON.parseObject(content);
        JSONArray jsonArray = JSON.parseArray(jsonObject.getString("Heats"));
        JSONObject jsonObject1 = JSON.parseObject(jsonArray.getString(0));
        JSONArray jsonArray1 = JSON.parseArray(jsonObject1.getString("Results"));
        for(int i = 0 ; i < jsonArray1.size();i++){
            JSONObject result = JSON.parseObject(jsonArray1.getString(i));
            Double total = result.getDouble("TotalPoints");
            String fullName = result.getString("FullName");
            int rank = result.getIntValue("Rank");
            JSONArray resultDetails = JSON.parseArray(result.getString("Dives"));
            Double[] score = new Double[resultDetails.size()];
            for(int j = 0 ; j < resultDetails.size();j++){
                JSONObject detail = JSON.parseObject(resultDetails.getString(j));
                score[j] = detail.getDouble("DivePoints");
            }
            ResultSimply resultSimply = new ResultSimply(fullName,rank,score,total);
            bw.write(resultSimply.toString());
        }
    }




}